<?PHP //$Id: backuplib.php,v 1.1 2007/11/23 23:31:18 krausze Exp $
error_reporting(E_ALL);
    function stupla_backup_mods($bf, $preferences) {
        global $CFG;

        $status = true;

        //Iterate over stupla table
        $stuplas = get_records ("stupla","course",$preferences->backup_course,"id");
        if ($stuplas) {
            foreach ($stuplas as $stupla) {
                if (function_exists('backup_mod_selected')) {
                    // Moodle >= 1.6
                    $backup_mod_selected = backup_mod_selected($preferences, 'stupla', $stupla->id);
                } else {
                    // Moodle <= 1.5
                    $backup_mod_selected = true;
                }
                if ($backup_mod_selected) {
                    $status = stupla_backup_one_mod($bf, $preferences, $stupla->id);
                }
            }
        }
        return $status;
    }

    function stupla_backup_one_mod($bf, $preferences, $instance=0) {
        // $bf : resource id for b(ackup) f(ile)
        // $preferences : object containing switches and settings for this backup
         $level = 3;
        $status = true;
        $table = 'stupla';
        $select = "course=$preferences->backup_course AND id='$instance'";
        $records_tag = '';
        $records_tags = array();
        $record_tag = 'MOD';
        $record_tags = array('MODTYPE'=>'stupla');
        $excluded_tags = array();
        $more_backup = '';
        if (function_exists('backup_userdata_selected')) {
            // Moodle >= 1.6
            $backup_userdata_selected = backup_userdata_selected($preferences, 'stupla', $instance);
        } else {
            // Moodle <= 1.5
            $backup_userdata_selected = $preferences->mods['stupla']->userinfo;
        }
        if ($backup_userdata_selected) {
            $more_backup .= '$status = stupla_backup_simple_table($bf, $record, $level, $status, "stupla_session", "SESSION");';
        	$more_backup .= '$status = stupla_backup_simple_table($bf, $record, $level, $status, "stupla_action", "ACTION");';
            $more_backup .= '$status = stupla_backup_simple_table($bf, $record, $level, $status, "stupla_ex", "EX");';
            $more_backup .= '$status = stupla_backup_simple_table($bf, $record, $level, $status, "stupla_sheet", "SHEET");';
            $more_backup .= '$status = stupla_backup_simple_table($bf, $record, $level, $status, "stupla_plan", "PLAN");';
        }
        return stupla_backup_records(
            $bf, $status, $level,
            $table, $select,
            $records_tag, $records_tags,
            $record_tag, $record_tags,
            $excluded_tags, $more_backup
        );
    }

	function stupla_backup_simple_table($bf, &$parent, $level, $status, $table, $record_tag) {
		// $parent is a reference to an attempt record
		$select = "stupla=$parent->id";
		$records_tag = '';
		$records_tags = array();
        $record_tags = array();
        $more_backup = '';
        $excluded_tags = array('id','stupla');
        return stupla_backup_records(
            $bf, $status, $level,
            $table, $select,
            $records_tag, $records_tags,
            $record_tag, $record_tags,
            $excluded_tags, $more_backup
        );
    }

    function stupla_backup_records(&$bf, $status, $level, $table, $select, $records_tag, $records_tags, $record_tag, $record_tags, $excluded_tags, $more_backup) {
        // general purpose backup function
        // $bf     : resource id of backup file
        // $status : current status of backup (true or false)
        // $level  : current depth level in the backup XML tree
        // $table  : table from which records will be selected and backed up
        // $select : SQL selection string
        // $records_tag  : optional XML tag which starts a group of records (and descends a level)
        // $records_tags : optional XML tags to be inserted at the start of a group of records
        // $record_tag   : optional XML tag which starts a record (and descends a level)
        // $record_tags  : optional XML tags to be inserted at the start of a record
        // $excluded_tags : fields which will NOT be backed up from the records
        // $more_backup   : optional PHP code to be eval(uated) for each record
        // If any of the "fwrite" statements fail,
        // no further "fwrite"s will be attempted
        // and the function returns "false".
        // Otherwise, the function returns "true".
        if ($status && ($records = get_records_select($table, $select, 'id'))) {
            // start a group of records
            if ($records_tag) {
                $status = $status && fwrite($bf, start_tag($records_tag, $level, true));
                $level++;
                foreach ($records_tags as $tag) {
                    $status = $status && fwrite($bf, full_tag($tag, $level, false, $value));
                }
            }
            foreach ($records as $record) {
                // start a single record
                if ($record_tag) {
                    $status = $status && fwrite($bf, start_tag($record_tag, $level, true));
                    $level++;
                    foreach ($record_tags as $tag=>$value) {
                        $status = $status && fwrite($bf, full_tag($tag, $level, false, $value));
                    }
                }
                // backup fields in this record
                $tags = get_object_vars($record);
                foreach ($tags as $tag=>$value) {
                    if (!is_numeric($tag) && !in_array($tag, $excluded_tags)) {
                        $status = $status && fwrite($bf, full_tag($tag, $level, false, stupla_safe_code($value)));
                    }
                }
                // backup related records, if required
                if ($more_backup) {
                    eval($more_backup);
                }
                // end a single record
                if ($record_tag) {
                    $level--;
                    $status = $status && fwrite($bf, end_tag($record_tag, $level, true));
                }
            }
            // end a group of records
            if ($records_tag) {
                $level--;
                $status = $status && fwrite($bf, end_tag($records_tag, $level, true));
            }
        }
        return $status;
    }
    ////Return an array of info (name, value)
    function stupla_check_backup_mods($course, $user_data=false, $backup_unique_code, $instances=null) {
        global $CFG;
        $info = array();
        if (isset($instances) && is_array($instances) && count($instances)) {
            foreach ($instances as $id => $instance) {
                $info += stupla_check_backup_mods_instances($instance,$backup_unique_code);
            }
        } else {
            // the course data
            $info[0][0] = get_string('modulenameplural','stupla');
            $info[0][1] = count_records('stupla', 'course', $course);

            // the user_data, if requested
            if ($user_data) {
                $table = "{$CFG->prefix}stupla h, {$CFG->prefix}stupla_action a";
                $select = "h.course = $course AND h.id = a.stupla";

                $info[1][0] = get_string('attempts', 'quiz');
                $info[1][1] = count_records_sql("SELECT COUNT(*) FROM $table WHERE $select");
            }
        }
        return $info;
    }

    ////Return an array of info (name, value)
    function stupla_check_backup_mods_instances($instance,$backup_unique_code) {
        global $CFG;
        $info = array();

        // the course data
        $info[$instance->id.'0'][0] = '<b>'.$instance->name.'</b>';
        $info[$instance->id.'0'][1] = '';

        // the user_data, if requested
        if (!empty($instance->userdata)) {
            $table = "{$CFG->prefix}stupla_action a";
            $select = "a.stupla = $instance->id";

            $info[$instance->id.'1'][0] = get_string('attempts', 'quiz');
            $info[$instance->id.'1'][1] = count_records_sql("SELECT COUNT(*) FROM $table WHERE $select");
        }
        return $info;
    }

	function stupla_safe_code($s) {
		if ( isset($s) ) {
			$s1 = str_replace("\x01", "&x01;", $s);
			$s1 = str_replace("\x02", "&x02;", $s1);
			$s1 = str_replace("\x05", "&x05;", $s1);
			$s1 = str_replace("\x06", "&x06;", $s1);
			$s1 = str_replace("\x08", "&x08;", $s1);
			$s1 = str_replace("\r", "", $s1);
			$s1 = str_replace("\n", "&xbr;", $s1);
			return $s1;
		}
		return $s;
	}

?>
