<?php

header("Expires: 0");

include 'protlib.php';
include 'data_load.php';

$session = GetSession($sessionid, $stupla);
$curSessionName = $session->displayname;

$PAGE->set_url('/mod/stupla/prot/prot_hist.php', array('id' => $cm->id));
$PAGE->navbar->ignore_active();
echo $OUTPUT->header();
?>
<style type="text/css"><!--
  td.login { font-weight:bold; color:#333333 }
  td.prot { font-weight:bold; color:#8A2BE2 }
  td.sheet { font-weight:bold; color:#7CFC00 }
  td.plan { font-weight:bold; color:#C000C0 }
  td.exercise { font-weight:bold; color:#228B22 }
  td.medium { font-weight:bold; color:#FF4500 }
  td.text { font-weight:bold; color:#000000 }
  td.textaction { font-weight:bold; color:#000000 }
  td.fb { font-weight:bold; color:#8B4513 }
  td.systerror { font-weight:bold; color:#2E8B57 }
  td.material { font-weight:bold; color:#FF008B }
  .exgood { font-weight:bold; color:#008000 }
  .exbad { font-weight:bold; color:#C00000 }
  .exshow { font-weight:bold; color:#404040 }
  a:active { font-weight:bold; color:#E00000; background-color:#8080F0; }
//--></style>

<table border="1">
 <tr>
  <td>
   t<sub>delta</sub> (in s)
  </td>
  <td>
   Aktion
  </td>
  <td>
   Bemerkung
  </td>
 </tr>
<?php

$sError = "";

function Abbridge($s, $n)
{
  return ( !empty($s) && strlen($s) > $n ) ? '<span title="'.$s.'">'.substr($s, 0, $n-3).'...</span>' : $s;
}

function MakeTopicName($topic, $nr = -1)
{
  global $Name;
  return "<b>".Abbridge($Name[$topic], 40)."</b> [".$topic.($nr != -1 && $nr != -99 ? ", ".$nr : "")."]";
}

function MakeMediaName($type, $topic, $nr = -1)
{
  global $Name;
  $sFile = GetMedia($type, $topic, $nr, 0);
  $j = strrpos($sFile, "/");
  if ( $j != FALSE )
    $sFile = substr($sFile, $j+1);
  if ( strlen($sFile) > 20 )
    $sFile = '<span title="'.$sFile.'">...'.substr($sFile, strlen($sFile)-18).'</span>';
  return "<b>".Abbridge($Name[$topic], 20).", ".Abbridge(GetMedia($type, $topic, $nr, 1), 30).
    '</b> ['.$topic.($nr != -1 && $nr != -99 ? ", ".$nr : "")."] <i>(".$sFile.")</i>";
}

function FileName($s)
{
  $i = strrpos($s, "/");
  return $i == FALSE ? $s : substr($s, $i+1);
}

$time = 0;
if ($records = $DB->get_records_select("stupla_action", "stupla='$stupla->id' AND session='$sessionid'", null, "starttime ASC", "*"))
	EnrichNONEGAME1($records);
	foreach ($records as $r) {
    $date1 = strftime("%a %d %b %y, %H:%M:%S", $r->starttime).' dur:'.$r->duration;
    if ( $r->media == STUPLA_LOGIN )
      echo '<tr style="background-color:#CCCCCC"><td align="right" title="'.$date1.'">0</td><td class="login">Login</td><td><b>'.
        $date1.'</b> '.$r->data."</td></tr>\r\n";
    else
    {
      echo '<tr><td align="right" title="', $date1, '">', $r->starttime-$time, '</td>';
      if ( $r->media == STUPLA_GENERIC ) {
          if ( substr($r->data, 0,5) == '#prot' )
             echo '<td class="prot">Protokoll</td><td>'.$r->data;
          else
             echo '<td class="material">Material</td><td>'.$r->data;
      }
      else if ( $r->media == STUPLA_SHEET ) {
      	$arr = explode(' ', $r->data);
        echo '<td class="sheet">Sammelm.</td><td>'.$r->data;
      }
      else if ( $r->media == STUPLA_PLAN ) {
      	$arr = explode(' ', $r->data);
        echo '<td class="plan">Lernplan.</td><td>'.$r->data;
      }
/*      else if ( $arr[1] == "#material" )
        echo '<td class="material">Material</td><td>'.$arrRest2;*/
      else if ( $r->media == STUPLA_MARK ) {
      	$arr = explode(' ', $r->data);
        echo '<td class="textaction">Markieren</td><td>'.MakeTopicName($arr[0]).', Worte: <b>'.$arr[1].' &ndash; '.$arr[2].'</b>, Farbe: <b>'.$arr[3].'</b>';
      }
      else if ( $r->media == STUPLA_NOTE )
      {
      	$arr = explode(' ', $r->data);
        $s = "";
        $i = 0;
        if ( $arr[$i] == "ERASE" )
        {
          $s = "<b>L&ouml;schen</b> ";
          $i++;
        }
        if ( $arr[$i] == "EDIT" )
        {
          $s = "<b>Bearbeiten</b> ";
          $i++;
        }
        echo '<td class="textaction">Notiz</td><td>'.$s.MakeTopicName($arr[$i]).', Positions-Wort: <b>'.$arr[$i+1].'</b>, Inhalt: <b>&quot;'.join(" ", array_slice($arr, $i+2)).'&quot;</b>';
      }
/*      else if ( $arr[1] == "#fbrequest" )
        echo '<td class="fb">Fragebogen</td><td>Anforderung Fragebogen Nr. <b>'.$arr[2].'</b>';
      else if ( $arr[1] == "#systerror" )
      {
        $arr2 = explode(".", $arr[2]);
        echo '<td class="systerror">Syst. Fehler</td><td>'.MakeMediaName($arr2[0], $arr2[1], $arr2[2])." ".join(" ", array_slice($arr, 3));
      }*/
      else // normale Aktion
      {
        $Mode = "Text";
        $s = "";
        if ( $r->result )
          $s = $r->result.' ';
        if ( $r->data )
          $s .= $r->data;
        if ( $r->media < 100 ) // Medium
        {
          $Mode = $MediaTitleShort[$r->media];
          if ( $r->media != $M_AUFGABE )
            echo '<td class="medium">'.$Mode.'</td><td>'.MakeMediaName($r->media, $r->topic, $r->nr).' '.$s;
          else
          {
            $s1 = "";
            if ( isset($r->result) )
            {
              $s = round($r->result, 2);
              if ( isset($r->data) )
                $s1 = $r->data;
            }
            if ( $s == -1 )
              echo '<td class="exercise">'.$Mode.'</td><td>'.MakeMediaName($M_AUFGABE, $r->topic, $r->nr).' <span class="exshow">Lösung angezeigt</span> <a href="javascript:top.control.ShowHistExercise(\''.GetMedia($M_AUFGABE, $r->topic, $r->nr, 0).'\',\'\')">=></a> '.str_replace("_", " ", str_replace("|", " | ", $s1));
            else
              echo '<td class="exercise">'.$Mode.'</td><td>'.MakeMediaName($M_AUFGABE, $r->topic, $r->nr).' <span class="ex'.($s > 98 ? "good" : "bad").'">'.$s.'%</span> <a href="javascript:top.control.ShowHistExercise(\''.GetMedia($M_AUFGABE, $r->topic, $r->nr, 0).'\',\''.str_replace("%", "###", urlencode($s1)).'\')">=></a> '.str_replace("_", " ", str_replace("|", " | ", $s1));
          }
        }
        else if ( $r->media >= M_TOCMEDIA && $r->media < STUPLA_SYSTERROR ) // InTOC
        {
          $Mode = $InTOCMediaTitleShort[$r->media-M_TOCMEDIA];
          echo '<td class="medium">'.$Mode.'</td><td>'.MakeMediaName($r->media, $r->topic, $r->nr).' '.$s;
        }
        else // Text
          echo '<td class="Text">'.$Mode.'</td><td>'.MakeTopicName($r->topic).' '.$s;
      }
      echo "</td></tr>\r\n";
    }
    $time = $r->starttime;
  }

if ( $time == 0 )
  echo '<tr><td colspan="3">Keine Datei vorhanden.</td></tr>';

?>
</table>
<?php
if ( $sError != "" )
    echo '<div class="errorbox">', $sError, '</div>';

echo $OUTPUT->footer();
?>